--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:36:52 04/29/2009
-- Design Name:   
-- Module Name:   C:/Xilinxwork/sh_drec2/tb_wr_ctrl.vhd
-- Project Name:  sh_drec2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: FM_WR_CTRL
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_wr_ctrl IS
END tb_wr_ctrl;
 
ARCHITECTURE behavior OF tb_wr_ctrl IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT FM_WR_CTRL
    PORT(
--			tp1	:	out	std_logic;
--			tp2	:	out	std_logic;
--			tpB	:	out	std_logic_vector(2 downto 0);
         CLK : IN  std_logic;
         RST_N : IN  std_logic;
         CVSYNC : IN  std_logic;
         CHSYNC : IN  std_logic;
         PCLK : IN  std_logic;
         MCLK : OUT  std_logic;
         CapStart : IN  std_logic;
         CapEnd : OUT  std_logic;
         CapBusy : OUT  std_logic;
         CD : IN  std_logic_vector(7 downto 0);
         grgb16 : OUT  std_logic_vector(15 downto 0);
         CamWriteAddr : OUT  std_logic_vector(19 downto 0);
--         CamReadAddr : OUT  std_logic_vector(19 downto 0);
         CamWriteWin : OUT  std_logic;
         CamReadWin : OUT  std_logic;
         CVSYNC_edge : OUT  std_logic;
		nLBLANK : OUT std_logic;
		LCLK : OUT std_logic;
		LVSYNC : OUT std_logic;
		LHSYNC : OUT std_logic;
		VgaReadWin	: OUT std_logic
        );
    END COMPONENT;
    
	constant	PERIOD : time := 21 ns;		--48MHz,mu0401

   --Inputs

   signal CLK : std_logic := '0';
   signal RST_N : std_logic := '0';
   signal CVSYNC : std_logic := '0';
   signal CHSYNC : std_logic := '0';
   signal PCLK : std_logic := '0';
   signal CapStart : std_logic := '0';
   signal CD : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal MCLK : std_logic;
   signal CapEnd : std_logic;
   signal CapBusy : std_logic;
   signal grgb16 : std_logic_vector(15 downto 0);
   signal CamWriteAddr : std_logic_vector(19 downto 0);
--   signal CamReadAddr : std_logic_vector(19 downto 0);
   signal CamWriteWin : std_logic;
   signal CamReadWin : std_logic;
   signal CVSYNC_edge : std_logic;
	signal nLBLANK : std_logic;
	signal LCLK : std_logic;
	signal LVSYNC : std_logic;
	signal LHSYNC : std_logic;
	signal VgaReadWin	: std_logic;
--	signal tp1	:	std_logic;
--	signal tp2	:	std_logic;
--	signal tpB	:	std_logic_vector(2 downto 0);

	
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: FM_WR_CTRL PORT MAP (
--			tp1	=>	tp1,
--			tp2	=>	tp2,
--			tpB	=>	tpB,
          CLK => CLK,
          RST_N => RST_N,
          CVSYNC => CVSYNC,
          CHSYNC => CHSYNC,
          PCLK => PCLK,
          MCLK => MCLK,
          CapStart => CapStart,
          CapEnd => CapEnd,
          CapBusy => CapBusy,
          CD => CD,
          grgb16 => grgb16,
          CamWriteAddr => CamWriteAddr,
--          CamReadAddr => CamReadAddr,
          CamWriteWin => CamWriteWin,
          CamReadWin => CamReadWin,
          CVSYNC_edge => CVSYNC_edge,
			nLBLANK	=> nLBLANK,
			LCLK		=> LCLK,
			LVSYNC	=> LVSYNC,
			LHSYNC	=> LHSYNC,
			VgaReadWin	=> VgaReadWin
        );
 
   -- No clocks detected in port list. Replace <clock> below with 
   -- appropriate port name 
 
--   constant <clock>_period := 1ns;
 
   CLK_process :process
   begin
		CLK <= '0';
		wait for PERIOD/2;
		CLK <= '1';
		wait for PERIOD/2;
   end process;

   PCLK_process :process
   begin
		PCLK <= '0';
		wait for PERIOD/2;
		PCLK <= '1';
		wait for PERIOD/2;
   end process;
 
--	CHSYNC_process : process
--	begin
--		wait for PERIOD*764*2;
--		CHSYNC <= '1';
--		wait for PERIOD*124*2;
--		CHSYNC <= '0';
--	end process;

	CHSYNC_process : process
	begin
		wait for PERIOD*640*2;		--*764*2;
		CHSYNC <= '0';
		wait for PERIOD*144*2;		--*124*2;
		CHSYNC <= '1';
	end process;


   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for PERIOD*10;		--100ms;
		RST_N <= '1';
		CapStart <= '1';
		wait for PERIOD*100;
		CVSYNC <= '1';
		wait for PERIOD*124*2*2;
		CVSYNC <= '0';
		
		wait for 16.712ms;
		CVSYNC <= '1';
		wait for PERIOD*124*2*2;
		CVSYNC <= '0';


      wait;
   end process;

END;
