--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   03:20:20 05/01/2009
-- Design Name:   
-- Module Name:   C:/Xilinxwork/sh_drec2/tb_top_level.vhd
-- Project Name:  sh_drec2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: top_level
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_top_level IS
END tb_top_level;
 
ARCHITECTURE behavior OF tb_top_level IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT top_level
    PORT(
         y : IN  std_logic_vector(7 downto 0);
         n_reset : IN  std_logic;
         xclk : IN  std_logic;
         CVSYNC : IN  std_logic;
         CHSYNC : IN  std_logic;
         PCLK : IN  std_logic;
         SCLK : OUT  std_logic;
         SDA : INOUT  std_logic;
         RSTB : OUT  std_logic;
         LR : OUT  std_logic_vector(7 downto 0);
         LG : OUT  std_logic_vector(7 downto 0);
         LB : OUT  std_logic_vector(7 downto 0);
         nLBLANK : OUT  std_logic;
         LCLK : OUT  std_logic;
         LVSYNC : OUT  std_logic;
         LHSYNC : OUT  std_logic;
         rec : IN  std_logic;
         MCLK : OUT  std_logic;
         mdata : INOUT  std_logic_vector(15 downto 0);
         n_cs0 : OUT  std_logic;
         n_cs1 : OUT  std_logic;
         n_cs2 : OUT  std_logic;
         n_cs3 : OUT  std_logic;
         n_oe : OUT  std_logic;
         n_wr : OUT  std_logic;
         m_address : OUT  std_logic_vector(17 downto 0);
         n_ble : OUT  std_logic;
         n_bhe : OUT  std_logic;
         rec_led : OUT  std_logic;
         PA10 : IN  std_logic;
         nCS1 : IN  std_logic;
         nCS2 : IN  std_logic;
         UA : IN  std_logic_vector(21 downto 0);
         UD : INOUT  std_logic_vector(15 downto 0);
         nWRL : IN  std_logic;
         nWRH : IN  std_logic;
         nRD : IN  std_logic;
         SD_CD : IN  std_logic;
         SD_CLK : OUT  std_logic;
         SD_CMD : OUT  std_logic;
         SD_DAT0 : IN  std_logic;
         SD_DAT1 : IN  std_logic;
         SD_DAT2 : IN  std_logic;
         SD_DAT3 : OUT  std_logic;
         SD_WP : IN  std_logic;
         PA15 : OUT  std_logic;
         PA7 : IN  std_logic;
         PB3 : IN  std_logic;
         PB4 : IN  std_logic;
         PB5 : OUT  std_logic;
         PB2 : OUT  std_logic;
         dummy : OUT  std_logic
        );
    END COMPONENT;
    
	COMPONENT sram_model
    Port ( n_wr : in std_logic;
           n_oe : in std_logic;
			  n_cs : in std_logic;
			  n_ble : in std_logic;
			  n_bhe : in std_logic;
           m_address : in std_logic_vector(17 downto 0);
           mdata : inout std_logic_vector(15 downto 0)
			 );
	END COMPONENT;

   --Inputs
   signal y : std_logic_vector(7 downto 0) := (others => '0');
   signal n_reset : std_logic := '0';
   signal xclk : std_logic := '0';
   signal CVSYNC : std_logic := '0';
   signal CHSYNC : std_logic := '0';
   signal PCLK : std_logic := '0';
   signal rec : std_logic := '0';
   signal PA10 : std_logic := '0';
   signal nCS1 : std_logic := '1';	--'0';
   signal nCS2 : std_logic := '1';	--'0';
   signal UA : std_logic_vector(21 downto 0) := (others => '0');
   signal nWRL : std_logic := '1';	--'0';
   signal nWRH : std_logic := '1';	--'0';
   signal nRD : std_logic := '1';	--'0';
   signal SD_CD : std_logic := '0';
   signal SD_DAT0 : std_logic := '0';
   signal SD_DAT1 : std_logic := '0';
   signal SD_DAT2 : std_logic := '0';
   signal SD_WP : std_logic := '0';
   signal PA7 : std_logic := '0';
   signal PB3 : std_logic := '0';
   signal PB4 : std_logic := '0';

	--BiDirs
   signal SDA : std_logic;
   signal mdata : std_logic_vector(15 downto 0);
   signal UD : std_logic_vector(15 downto 0);

 	--Outputs
   signal SCLK : std_logic;
   signal RSTB : std_logic;
   signal LR : std_logic_vector(7 downto 0);
   signal LG : std_logic_vector(7 downto 0);
   signal LB : std_logic_vector(7 downto 0);
   signal nLBLANK : std_logic;
   signal LCLK : std_logic;
   signal LVSYNC : std_logic;
   signal LHSYNC : std_logic;
   signal MCLK : std_logic;
   signal n_cs0 : std_logic;
   signal n_cs1 : std_logic;
   signal n_cs2 : std_logic;
   signal n_cs3 : std_logic;
   signal n_oe : std_logic;
   signal n_wr : std_logic;
   signal m_address : std_logic_vector(17 downto 0);
   signal n_ble : std_logic;
   signal n_bhe : std_logic;
   signal rec_led : std_logic;
   signal SD_CLK : std_logic;
   signal SD_CMD : std_logic;
   signal SD_DAT3 : std_logic;
   signal PA15 : std_logic;
   signal PB5 : std_logic;
   signal PB2 : std_logic;
   signal dummy : std_logic;

   -- Clock period definitions
   constant xclk_period : time := 21 ns;		--1us;
	constant	PERIOD : time := 21 ns;		--48MHz,mu0401
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: top_level PORT MAP (
          y => y,
          n_reset => n_reset,
          xclk => xclk,
          CVSYNC => CVSYNC,
          CHSYNC => CHSYNC,
          PCLK => PCLK,
          SCLK => SCLK,
          SDA => SDA,
          RSTB => RSTB,
          LR => LR,
          LG => LG,
          LB => LB,
          nLBLANK => nLBLANK,
          LCLK => LCLK,
          LVSYNC => LVSYNC,
          LHSYNC => LHSYNC,
          rec => rec,
          MCLK => MCLK,
          mdata => mdata,
          n_cs0 => n_cs0,
          n_cs1 => n_cs1,
          n_cs2 => n_cs2,
          n_cs3 => n_cs3,
          n_oe => n_oe,
          n_wr => n_wr,
          m_address => m_address,
          n_ble => n_ble,
          n_bhe => n_bhe,
          rec_led => rec_led,
          PA10 => PA10,
          nCS1 => nCS1,
          nCS2 => nCS2,
          UA => UA,
          UD => UD,
          nWRL => nWRL,
          nWRH => nWRH,
          nRD => nRD,
          SD_CD => SD_CD,
          SD_CLK => SD_CLK,
          SD_CMD => SD_CMD,
          SD_DAT0 => SD_DAT0,
          SD_DAT1 => SD_DAT1,
          SD_DAT2 => SD_DAT2,
          SD_DAT3 => SD_DAT3,
          SD_WP => SD_WP,
          PA15 => PA15,
          PA7 => PA7,
          PB3 => PB3,
          PB4 => PB4,
          PB5 => PB5,
          PB2 => PB2,
          dummy => dummy
        );

sut0: sram_model port map(
		n_wr	=> n_wr,
      n_oe	=> n_oe,
		n_cs	=> n_cs0,
		n_ble	=> n_ble,
		n_bhe	=> n_bhe,
      m_address	=> m_address,
      mdata	=> mdata
	);

sut1: sram_model port map(
		n_wr	=> n_wr,
      n_oe	=> n_oe,
		n_cs	=> n_cs1,
		n_ble	=> n_ble,
		n_bhe	=> n_bhe,
      m_address	=> m_address,
      mdata	=> mdata
	);

sut2: sram_model port map(
		n_wr	=> n_wr,
      n_oe	=> n_oe,
		n_cs	=> n_cs2,
		n_ble	=> n_ble,
		n_bhe	=> n_bhe,
      m_address	=> m_address,
      mdata	=> mdata
	);

sut3: sram_model port map(
		n_wr	=> n_wr,
      n_oe	=> n_oe,
		n_cs	=> n_cs3,
		n_ble	=> n_ble,
		n_bhe	=> n_bhe,
      m_address	=> m_address,
      mdata	=> mdata
	);


   -- Clock process definitions
   xclk_process :process
   begin
		xclk <= '0';
		wait for xclk_period/2;
		xclk <= '1';
		wait for xclk_period/2;
   end process;

   pclk_process :process
   begin
		PCLK <= '0';
		wait for xclk_period/2;
		PCLK <= '1';
		wait for xclk_period/2;
   end process;
 
	CHSYNC_process : process
	begin
		wait for PERIOD*640*2;		--*764*2;
		CHSYNC <= '0';
		wait for PERIOD*144*2;		--*124*2;
		CHSYNC <= '1';
	end process;

	CVSYNC_process	:	process
	begin
      wait for PERIOD*10;
		
		wait for PERIOD*100;
		CVSYNC <= '1';
		wait for PERIOD*124*2*2;
		CVSYNC <= '0';
		
		wait for 16.712ms;
		CVSYNC <= '1';
		wait for PERIOD*124*2*2;
		CVSYNC <= '0';

		wait;
	end process;
	
	CAMDATA_process : process
	begin
		wait until n_reset='1';
		for L in 1 to 525 loop
			wait until CHSYNC='0';
			wait until CHSYNC='1';
			for I in 1 to 640 loop
				y <= x"AB";
				wait for PERIOD;
				y <= x"CD";
				wait for PERIOD;
				y <= x"AB";
				wait for PERIOD;
				y <= x"EF";
				wait for PERIOD;
			end loop;
		end loop;
		y <= x"00";
		wait;
	end process;

	Ucom_process : process
	begin
      wait for PERIOD*20;
		UA <= "0100000000000000000000";	--x"900000";	Capture Start
		nCS2 <= '0';
		UD <= x"0001";
		nWRL <= '0';
		nWRH <= '0';
		wait for 100ns;	--40ns;
		nWRL <= '1';
		nWRH <= '1';
		nCS2 <= '1';
		UD <= (others => 'Z');
		
		wait for 17ms;
		UA <= "0100000000000000000000";	--x"900000";	Capture End?
		nCS2 <= '0';
		nRD <= '0';
		wait for 100ns;	--40ns;
		nRD <= '1';
		nCS2 <= '1';
		wait for PERIOD*20;

		UA <= "0100000000000000000000";	--x"900000";  PlayMode
		nCS2 <= '0';
		UD <= x"8000";
		nWRL <= '0';
		nWRH <= '0';
		wait for 100ns;	--40ns;
		nWRL <= '1';
		nWRH <= '1';
		nCS2 <= '1';
		UD <= (others => 'Z');
		wait for 1ms;

		UA <= "0100000000000000000000";	--x"900000";  PlayMode Off=EE mode
		nCS2 <= '0';
		UD <= x"0000";
		nWRL <= '0';
		nWRH <= '0';
		wait for 100ns;	--40ns;
		nWRL <= '1';
		nWRH <= '1';
		nCS2 <= '1';
		UD <= (others => 'Z');
		wait for PERIOD*20;

		UA <= "0100000000000000000110";	--x"900006";  SramAccessEnb
		nCS2 <= '0';
		UD <= x"0020";		--x"20";
		nWRL <= '0';			--nRD <= '0';
		nWRH <= '0';
		wait for 100ns;	--40ns;
		nWRL <= '1';			--nRD <= '1';
		nWRH <= '1';
		nCS2 <= '1';
		UD <= (others =>'Z');
		
		UA <= "1000000000000000000000";	--x"A00000"; Video Sram
		nCS2 <= '0';
		nRD <= '0';
		wait for 100ns;	--40ns;
		nRD <= '1';
		nCS2 <= '1';
		wait for 100ns;
		for J in 1 to 307200 loop
			UA <= UA + 1;
			nCS2 <= '0';
			nRD <= '0';
			wait for 100ns;	--40ns;
			nRD <= '1';
			nCS2 <= '1';
			wait for 100ns;
		end loop;
			
			
		wait;

	end process;
			

   -- Stimulus process
   stim_proc: process
   begin
      -- hold reset state
      wait for PERIOD*10;
		n_reset <= '1';
		





      wait;
   end process;

END;
