/**********************************************************
  MMCJ[hhCo(SPI[h / oCgPI/O^Cv)
  CQ Tech-I Vol. 35p
     Original Version Interface 2006.3  FJ
               TECH-I   Version 2006.9  chv
 **********************************************************/

#include "TYPEDEF.H"
#include "MMC_IO.H"
#include "MMCDRV.H"
#include "diskio.h"				//mu0308

#define _CALC_CRC
/* #define _DEBUG */
#ifdef _DEBUG
#include <stdio.h>
#endif

/*
 *
 *  SPIR}h`(rbg6'1'𗧂Ă)
 *
 */
#define	CMD0		0x40    /* CMD0  J[hZbg */
#define	CMD1		0x41    /* CMD1  J[hvZXN */
#define	CMD9		0x49    /* CMD9  CSDWX^l擾 */
#define	CMD10		0x4A    /* CMD10 CIDWX^l擾 */
#define	CMD12		0x4C    /* CMD12 [hf[^̏I */
#define	CMD13		0x4D    /* CMD13 StatusWX^̒l擾 */
#define	CMD16		0x50    /* CMD16 f[^ubN̐ݒ */
#define	CMD17		0x51    /* CMD17 ZN^[h */
#define	CMD18		0x52    /* CMD18 CMD12ŏI܂ŃZN^[h */
#define	CMD23		0x57    /* CMD23 CMD17œǂݏoubN̐ݒ */
#define	CMD24		0x58    /* CMD24 ZN^Cg */
#define	CMD41		0x69    /* CMD41 */
#define	CMD55		0x77    /* CMD55 APP_CMD */
#define	CMD58		0x7A    /* CMD58 OCRWX^l擾 */
#define	CMD59		0x7B    /* CMD59 CRCIvV̐ݒ/ */


/* 萔` */
#define SECTOR_SIZE             (512)   /* 1ZN^̃TCY */
#define CID_SIZE                (16)    /* CIDWX^̃TCY */
#define CSD_SIZE                (16)    /* CSDWX^̃TCY */
#define	MMC_TIMEOUT		0x300
#define	CS_Enable		1
#define	CS_Disable		0

#define DATA_TOKEN		0xFE    /* f[^g[NX^[goCg */
#define DUMMY_DATA		0xFF    /* _~[f[^ */

#define CSD_WRITE_BL_LEN(c)       (((c[12] & 0x03) << 2) | (c[13] >> 6))
#define CSD_WRITE_BL_PARTIAL(c)   ((c[13] >> 5) & 0x01)
#define CSD_READ_BL_LEN(c)        ((c[5] & 0x0f))
#define CSD_READ_BL_PARTIAL(c)    ((c[6]  >> 7))
#define CSD_C_SIZE(c)             (((UWORD)(c[6] & 0x03) << 10) | ((UWORD)c[7] << 2) | ((c[8] >> 6) & 0x03))
#define CSD_C_SIZE_MULT(c)        (((c[9] & 0x03) << 1) | (c[10] >> 7))

/* O[oϐ` */
static ULONG MAX_LBA;           /* őZN^TCY */

static volatile
DSTATUS Stat = STA_NOINIT;	/* Disk status mu0308 */

/***** MMC SPIhCo֐ *****/
#ifdef _CALC_CRC
/**
 * 
 *  CRC7̌vZ
 *
 *  X7+X3+1
 *
 *  @param chr  CRCvZz̃|C^
 *  @param cnt  z
 *
 *  @return    vZ
 */
static UBYTE CRC7(const UBYTE * chr, const int cnt)
{
    int i, a;
    UBYTE crc, data;

    crc = 0;
    for (a = 0; a < cnt; a++) {
        data = chr[a];
        for (i = 0; i < 8; i++) {
            crc <<= 1;

            if ((data & 0x80) ^ (crc & 0x80))
                crc ^= 0x09;
            data <<= 1;
        }
    }
    crc = (crc << 1) | 1;
    return (crc);
}

/**
 *
 *  CRC16(CRC CCITT)̌vZ
 *
 *  @param chr  CRCvZz̃|C^
 *  @param cnt  z
 *
 *  @return    vZ
 */
static UWORD CRC16(const UBYTE * chr, const int cnt)
{
    int i, a, v;
    UWORD crc;
    UBYTE data;
    crc = 0x0000;
    for (a = 0; a < cnt; a++) {
        data = chr[a];
        for (i = 0; i < 8; i++) {
            v = (crc & 0x8000);
            crc <<= 1;
            if (data & 0x80)
                crc |= 1;
            if (v)
                crc ^= 0x1021;
            data <<= 1;
        }
    }

    for (i = 0; i < 16; i++) {
        v = (crc & 0x8000);
        crc <<= 1;
        if (v)
            crc ^= 0x1021;
    }

    return crc;
}
#endif

/**
 *
 *      rW[ԃNA҂
 *
 *          Dinf[^g[N܂őҋ@Af[^MB
 *
 *      @return  X|Xl   0     I
 *                              other G[R[h
 */
//static int mmc_busywait(void)
int mmc_busywait(void)
{
    ULONG i;
    UBYTE c;
    for (i = 0; i < MMC_TIMEOUT; i++) {

        c = mmcio_Recv1byte();

        if (c == DUMMY_DATA)
            return 0;           /* rW[NA */

        /* rW[Ԃ̂ƂDout"L"Ȃ̂ŎMf[^00h */
        /* 0ȊO̒lɂȂƂ́ArW[NA */
    }
    return MMC_TIMEOUT_ERROR;   /* J[h܂rW[ԂŃ^CAEg */
}

/**
 *
 *      ubNf[^M
 *
 *          f[^g[N܂őҋ@Af[^MB
 *
 *      @param   buff   Mobt@
 *      @param   len    M钷
 *      @param   Count  M
 *
 *      @return  X|Xl   0     I
 *                              other G[R[h
 */
static int mmc_sendblock(const UBYTE * buff, const int len)
{
    ULONG i;
    UBYTE c;
#ifdef _CALC_CRC
    UWORD crc = CRC16(buff, len);
#endif
    /* Dummy Clock N(wr) && busywait */
    i = mmc_busywait();

    if (i == MMC_TIMEOUT)
        return MMC_TIMEOUT_ERROR;       /* ^CAEg */

    mmcio_Send1byte(DATA_TOKEN);        /* f[^g[NX^[gM */

    /* f[^M */

    for (i = 0; i < len; i++) {
        mmcio_Send1byte(*buff++);
    }

    /*    CRC16M   */
#ifdef _CALC_CRC
    mmcio_Send1byte((crc >> 8));
    mmcio_Send1byte((crc & 0xFF));
#else
    mmcio_Send1byte(DUMMY_DATA);        /* _~[CRCM */
    mmcio_Send1byte(DUMMY_DATA);        /* _~[CRCM */
#endif
    /* f[^X|Xg[NM҂ */
    for (i = 0; i < MMC_TIMEOUT; i++) {

        c = mmcio_Recv1byte() & 0x1F;

        if ((c == DATA_NO_ERROR)
            || (c == DATA_CRC_ERROR)
            || (c == DATA_WRITE_ERROR))
            break;

    }
    if (c == DATA_NO_ERROR)
        return 0;               /* I */
    if (i == MMC_TIMEOUT)
        return MMC_TIMEOUT_ERROR;       /* ^CAEg */
    return (W_OFF | c);         /* ̂ق̃G[(8rbgɃX|Xl) */
}

/**
 *
 *      ubNf[^M
 *
 *          f[^g[N܂őҋ@Af[^MB
 *
 *      @param   buff   Mobt@
 *      @param   len    M钷
 *      @param   Count  M
 *
 *      @return  X|Xl   0     I
 *                              other G[R[h
 */
int mmc_recvblock(UBYTE * buff, int len, const UWORD Count)		//static
{
    UBYTE c;
    UWORD l, i;
    for (l = 0; l < Count; l++) {
        /* f[^g[NX^[goCgM҂ */
        /* Skip Dummy Clock (N ac)  &&     */
        /* Wait Data Token or Error Code.  */
        for (i = 0; i < MMC_TIMEOUT; i++) {
            c = mmcio_Recv1byte();
            if (c != DUMMY_DATA)
                break;
        }

        if (i == MMC_TIMEOUT)
            return MMC_TIMEOUT_ERROR;   /* ^CAEg */
        else if (c != DATA_TOKEN)
            return (R_OFF | c);

        /* f[^M */
        for (i = 0; i < len; i++) {
            *buff = mmcio_Recv1byte();
            buff++;
        }

        /* CRC16 ǂݎ̂ */
        mmcio_Recv1byte();
        mmcio_Recv1byte();
    }
    return 0;                   /* I */
}

/**
 *
 *      SPIR}hg[Ns
 *
 *      @param   spi_cmd R}h
 *      @param   param   R}hp[^
 *      @param   crc     CRC7
 *                       (0^ꂽꍇ _CALC_CRC`ĂvZAȊO̓_~[l 0xFF)
 *
 *      @return  X|Xl   0     I
 *                              other G[R[h
 */
int mmc_commandtoken(const UBYTE spi_cmd, const ULONG param,
                            const UBYTE crc)								//static
{
    int response;
    UBYTE cmd[6];
    ULONG i;
    /* R}hM҂ */
    response = mmc_busywait();
    if (response)
        return MMC_TIMEOUT_ERROR;
    /* R}hg[NM */
    cmd[0] = spi_cmd;
    cmd[1] = param >> 24;
    cmd[2] = param >> 16;
    cmd[3] = param >> 8;
    cmd[4] = param;
#ifdef _CALC_CRC
    cmd[5] = (crc == 0) ? CRC7(cmd, 5) : crc;
#else
    cmd[5] = (crc == 0) ? 0xFF : crc;
#endif
    for (i = 0; i < sizeof(cmd); i++) {
        mmcio_Send1byte(cmd[i]);
    }
    /* R}hg[NX|XM */
    for (i = 0; i < MMC_TIMEOUT; i++) {
        response = mmcio_Recv1byte();
        if ((response & 0x80) == 0)
            break;
    }
    if (i == MMC_TIMEOUT)
        return MMC_TIMEOUT_ERROR;       /* ^CAEg */
    return (C_OFF | response);  /* 0ŐI */
}

/**
 *
 *      ubNݒ
 *
 *  @param   BlockLen ubN
 *
 *  @return  X|Xl   0     I
 *                          other G[R[h
 */
static int MMC_SetBlockLen(ULONG BlockLen)
{
    int response;
    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    mmcio_CsCtrl(CS_Enable);    /* CSCl[u */
    response = mmc_commandtoken(CMD16, BlockLen, 0x00);

    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);   /* CSfBZ[u */
    return response;            /* 0ŐI */
}

/**
 *
 *      SPI CRC ON/OFF
 *
 *  @param   Flag IIt
 *
 *  @return  X|Xl   0     I
 *                          other G[R[h
 */
static int MMC_CRC_On_Off(ULONG Flag)
{
    int response;
    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    mmcio_CsCtrl(CS_Enable);

    response =
        mmc_commandtoken(CMD59, (Flag) ? 1 : 0, (Flag) ? 0x83 : 0x91);

    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);
    return response;            /* 0ŐI */
}

/***** OĂ΂֐ *****/
/**
 *
 *      J[hXe[^X擾
 *
 *
 *
 *  @return  X|Xl   J[hXe[^X
 *                          (15 .. 8) ǉG[
 *                          (7  .. 0) R}hX|X
 *                          other G[R[h
 */
int MMC_GetStatus()
{
    int response;
    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    mmcio_CsCtrl(CS_Enable);    /* CSCl[u */

    response = mmc_commandtoken(CMD13, 0, 0);
    if (response >= 0)
        response |= ((UWORD) mmcio_Recv1byte() << 8);

    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);   /* CSfBZ[u */
    return response;            /* 0ŐI  */
}

/**
 *
 *      CSDWX^l擾
 *
 *  @param   buff WX^l擾obt@(16 Byte ȏKv)
 *
 *  @return  X|Xl   0     I
 *                          other G[R[h
 */
int MMC_GetCSD(UBYTE * buff)
{
    int response;

    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    mmcio_CsCtrl(CS_Enable);    /* CSCl[u */

    response = mmc_commandtoken(CMD9, 0, 0xAF);

    if (response == 0) {        /* f[^MJn */
        response = mmc_recvblock(buff, CSD_SIZE, 1);
    }

    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);
    return response;
}

/**
 *
 *      CIDWX^l擾
 *
 *  @param   buff WX^l擾obt@(16 Byte ȏKv)
 *
 *  @return  X|Xl   0     I
 *                          other G[R[h
 */
int MMC_GetCID(UBYTE * buff)
{
    int response;

    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    mmcio_CsCtrl(CS_Enable);    /* CSCl[u */

    response = mmc_commandtoken(CMD10, 0, 0x1B);

    if (response == 0) {        /* f[^MJn */
        response = mmc_recvblock(buff, CID_SIZE, 1);
    }

    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);   /* CSfBZ[u */

    return response;

}

/**
 *
 *      MMCZN^f[^ǂݏo
 *
 *      @param   lba   _ubNAhX
 *      @param   buff  ǂݏoʊi[obt@
 *      @param   Count ǂݏoJEg
 *
 *      @return  X|Xl   0     I
 *                          other G[R[h
 */
int MMC_Read(ULONG lba, UBYTE * buff, const UWORD Count)
{
    int response;
    UBYTE *p = buff;
    ULONG address;
    UWORD l;

    if (Count == 0)
        return 0;
    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;
    /* ZN^mF */
    if (MAX_LBA <= lba)
        return MMC_LBA_RANGE_ERROR;
    if (MAX_LBA < (lba + Count))
        return MMC_LBA_RANGE_ERROR;

    for (l = 0; l < Count; l++) {       /* Count[v */
        /* LBAԍAhXϊ */
        address = lba * SECTOR_SIZE;

        /* CS = L */
        mmcio_CsCtrl(CS_Enable);

        /* CMD17 s */
        response = mmc_commandtoken(CMD17, address, 0x00);

        if (response != 0)
            goto read_error;

        /* f[^MJn */

        response = mmc_recvblock(p, SECTOR_SIZE, 1);

        if (response != 0)
            goto read_error;

        /* Dummy Clock && CS = H */
        mmcio_CsCtrl(CS_Disable);       /* CSfBZ[u */

        lba++;                  /* ̏݃ZN^ */
        p += SECTOR_SIZE;       /* ̏݃f[^̐擪AhX */
    }
    return response;
  read_error:
    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);   /* CSfBZ[u */
    return response;
}

/**
 *
 *      MMCZN^f[^o
 *
 *      @param   lba   _ubNAhX
 *      @param   buff  of[^i[obt@
 *      @param   Count oJEg
 *
 *      @return  X|Xl   0     I
 *                          other G[R[h
 */
int MMC_Write(ULONG lba, const UBYTE * buff, const UWORD Count)
{
    int response = 0;
    ULONG address;
    const UBYTE *p = buff;
    UWORD l;

    if (Count == 0)
        return 0;
    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    /* J[hCgveNgXCb`Ԍo */
    if (mmcio_WritePortectCheck())
        return MMC_WRITE_PROTECT_ERROR;

    /* ZN^mF */
    if (MAX_LBA <= lba)
        return MMC_LBA_RANGE_ERROR;
    if (MAX_LBA < (lba + Count))
        return MMC_LBA_RANGE_ERROR;

    for (l = 0; l < Count; l++) {       /* Count[v */

        /* LBAԍAhXϊ */
        address = lba * SECTOR_SIZE;

        /* CS = L */
        mmcio_CsCtrl(CS_Enable);

        /* CMD24 s */
        response = mmc_commandtoken(CMD24, address, 0x00);

        if (response != 0)
            goto write_error;

        /* f[^M */
        response = mmc_sendblock(p, SECTOR_SIZE);

        if (response != 0)
            goto write_error;

        /* Dummy Clock && CS = H */
        mmcio_CsCtrl(CS_Disable);       /* CSfBZ[u(łCS DisableĂ܂Ă悢) */
        /* response=mmc_busywait();     * rW[NA҂     */
        /* if (response)                * ^CAEg`FbN */
        /*   goto write_error; */
        lba++;                  /* ̏݃ZN^   */
        p += SECTOR_SIZE;       /* ̏݃f[^̐擪AhX */
    }
    return response;
  write_error:
    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);   /* CSfBZ[u */
    return response;
}

/**
 *
 *      MMCJ[h
 *
 *
 *      @return  X|Xl   0     I
 *                          other G[R[h
 */
int MMC_CardInit(void)
{
    int Block_Len, Mult;
    int response;
    UBYTE csd[CSD_SIZE];
    ULONG l;
    /* J[h}Ԍo */
    if (mmcio_CardDetectCheck() == 0)
        return MMC_CARD_DECTECT_ERROR;

    mmcio_CsCtrl(CS_Disable);   /* CSfBZ[u */

    for (l = 0; l < 10; l++) {
        mmcio_Send1byte(DUMMY_DATA);    /* _~[80NbNM */
    }

    /* MMCJ[hZbg */
    /* CS = L */
    mmcio_CsCtrl(CS_Enable);

    /* CMD0 s */
    response = mmc_commandtoken(CMD0, 0, 0x95);

    mmcio_Recv1byte();          /* Dummy Clock N(rc) */

    /* ̒iKłCARD_IS_NOT_READYԂ̂͂ */
    if ((response & 0xF000) == C_OFF) {
        if (!((response & 0x0FFF) & CARD_IS_NOT_READY))
            return response;
    } else
        return response;

    /* MMCJ[hvZXN */
    for (l = 0; l < MMC_TIMEOUT; l++) {

        /* CMD1𔭍s   */
        response = mmc_commandtoken(CMD1, 0, 0xF9);

        if (response == 0)
            break;
    }
    /* Dummy Clock && CS = H */
    mmcio_CsCtrl(CS_Disable);

    if (l == MMC_TIMEOUT) {
        return MMC_TIMEOUT_ERROR;       /* ^CAEg */
    } else if (response) {
        return response;
    }

    /*
     *
     *  SPI[hł̓ftHgłCRC͔veNg[hɂȂ͂ǂݏ
     *@sJ[ĥŖION/OFFw肵ĂB
     *
     */
#ifdef _CALC_CRC
    response = MMC_CRC_On_Off(1);
#else
    response = MMC_CRC_On_Off(0);
#endif
    /* CRCݒG[ */
    if (response)
        return MMC_INIT_ERROR;

    /*
     *
     *   CSDWX^擾ъep[^vZ
     *
     */
    response = MMC_GetCSD(csd);
    /* CSD擾G[  */
    if (response)
        return MMC_INIT_ERROR;

    /* f[^ubN (Byte) */
    Block_Len = 1 << (CSD_READ_BL_LEN(csd));

    /* ftHg512oCg */
    if (Block_Len != SECTOR_SIZE) {
        /*
         *
         *  SDJ[h2Gȏł̓ubN1024oCgȏB
         *  ǂݏ̃ubNCSD̒lƈĎۂ512oCg
         *  ɂȂĂ̂قƂǂ̂͂AɋHCSD̒l
         *  ǂ1024oCgȏɂȂĂ̂邩
         *  ̂lăf[^ubN512oCgɐݒ肵ĂB
         *
         *    SDCSDREAD_BL_LEN=WRITE_BL_LENŏɓ̂ŁA
         *   WRITE_BL_LEN͒PɃJ[heʂ̂߂̃p^Ƃ݂ȂB
         *
         *  (͎茳2G̃J[hňȉ̓삾)
         *
         *  1.SET_BLOCK_LEN1024p^G[NB
         *  2.SET_BLOCK_LEN512ɂȂĂAWRITE
         *    512oCgA1024oCg͎sB
         *  3.READłl1024oCgƌ㔼510oCg͂炭0xFFB
         *
         *    WRITE_BL_LEN=10, WRITE_BL_PARTIAL=01024oCg̃J[h
         *  Ŏۂ݂̏̓p^ǂ̃J[hꍇ
         *  MMCp̃hCoł̓ubN512oCĝ݂̑ΉƂ
         *  Ă߂邵ȂB
         *
         */
        /* f[^ubN̐ݒ */
        response = MMC_SetBlockLen(SECTOR_SIZE);
        /* f[^ubNݒG[ */
        if (response)
            return MMC_INIT_ERROR;
    }

    /* CSDWX^lJ[heʌvZALBA̍ő吔擾  */

    /* MultlvZ */
    Mult = 1 << (CSD_C_SIZE_MULT(csd) + 2);

    /* LBǍvZ */
    /* g[^LBAubN */
    MAX_LBA = (CSD_C_SIZE(csd) + 1) * Mult * (Block_Len / SECTOR_SIZE);

	/* Initialization succeded */
	Stat &= ~STA_NOINIT;		/* Clear STA_NOINIT */

    return 0;
}
