/***********************************************************************/
/*                                                                     */
/*  FILE        :vga_sd.c                                              */
/*  DATE        :Sun, May 24, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH7144F                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.13).    */
/*                                                                     */
/***********************************************************************/
/***********************************************************************
			SD-Card controller for CMOS-Camera
------------------------------------------------------------------------
			gWX^ZpQOOXNVWiÚj
			@@@@@@@@@@@@@@@@@@J` (M.Urushidani)
************************************************************************
	CMOS-Camera: KBCR-M04VGiVLmnCebNj
	CPU  Board : Interface2006.5tCQ-7144(C[GXs[j
	FPGA Board : CQ-SP3EDW208CQ-BBIMGiC[GXs[j
	File Format: bmp
	Image Size : 640x480(VGA)
	Input Format: GRGB/pix
	FAT system : FatFs(zzt[byԏjj2008N
************************************************************************/	

//#include <stdio.h>
#include "TYPEDEF.H"
#include "MMCDRV.H"
#include "DUMP.H"
#include "integer.h"
#include "ff.h"
#include "diskio.h"
#include <string.h>
#include "iodefine.h"
#include "cpu_uart.h"
#include "cq_printf.h"

//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

/***************** I/O memory map ******************/
#define	CPCTRL	(*((unsigned short *)0x00900000))
#define	SCTRL	(*((unsigned short *)0x00900002))
#define	SADDT	(*((unsigned short *)0x00900004))
#define	MISC	(*((unsigned short *)0x00900006))
#define	IOCTRL	(*((unsigned short *)0x00900008))
#define	LEDDLY	(*((unsigned short *)0x0090000A))

#define	MEM0	(*((unsigned short *)0x00A00000))
#define	MEM1	(*((unsigned short *)0x00A96000))
#define	MEM2	(*((unsigned short *)0x00B2C000))

#define	SIDOL	(*((unsigned short *)0xFFFF8622))
#define	SWAIT	(*((unsigned short *)0xFFFF8624))

#define PACRL1	(*((unsigned short *)0xFFFF838C))
#define PACRL2	(*((unsigned short *)0xFFFF838E))
#define PBCR1	(*((unsigned short *)0xFFFF8398))
#define PBCR2	(*((unsigned short *)0xFFFF839A))
#define PCCR	(*((unsigned short *)0xFFFF839C))
#define PDCRL1	(*((unsigned short *)0xFFFF83AC))
#define PDCRL2	(*((unsigned short *)0xFFFF83AE))
#define	PEDR	(*((unsigned short *)0xFFFF83B0))
#define	PEIOR	(*((unsigned short *)0xFFFF83B4))
#define PECRL2	(*((unsigned short *)0xFFFF83BA))

#define	CMSTR	(*((unsigned short *)0xFFFF83D0))
#define	CMCSR0	(*((unsigned short *)0xFFFF83D2))
#define	CMCNT0	(*((unsigned short *)0xFFFF83D4))
#define	CMCOR0	(*((unsigned short *)0xFFFF83D6))

#define BCR1 (*((unsigned short *)0xFFFF8620))
#define BCR2 (*((unsigned short *)0xFFFF8622))
#define WCR1 (*((unsigned short *)0xFFFF8624))
#define WCR2 (*((unsigned short *)0xFFFF8626))

/******************* macros *****************/
#define SFT_BYTE1(x) (  x		 & 0xFF)
#define SFT_BYTE2(x) (( x >> 8 ) & 0xFF)
#define SFT_BYTE3(x) (( x >> 16) & 0xFF)
#define SFT_BYTE4(x) (( x >> 24) & 0xFF)
#define INV_INT16(x) ( (unsigned short)(SFT_BYTE1(x)<<8 | SFT_BYTE2(x)) )
#define INV_INT32(x) ( SFT_BYTE1(x)<<24 | SFT_BYTE2(x)<<16 | SFT_BYTE3(x)<<8 | SFT_BYTE4(x) )

/*************** variables ******************/
volatile unsigned short tmpus;
char xBuffer[2048];			/* transfer buffer for sram to sd */
char linebuf[80];			/* Console input buffer */
BYTE Buff[512];				/* Working buffer */
FATFS fatfs;				/* File system object */
DWORD acc_size;				/* Work register for fs command */
WORD acc_files, acc_dirs;
FILINFO finfo;
extern BYTE rtcYear, rtcMon, rtcMday, rtcHour, rtcMin, rtcSec;
extern BYTE RTC_SEC,RTC_MIN,RTC_HOUR,RTC_DOW,RTC_DOM,RTC_MONTH;
extern WORD RTC_YEAR;

static FRESULT scan_files (char*);
static void put_rc (FRESULT);

FIL file1, file2;			/* File objects */
const char FileName[9] = "VGA0.bmp";

unsigned char FileOpen(void);
long imagedata(int, int, unsigned char**, long);  	

/******************* main routine *****************/
void main(void)
{
/*------------- local variables ----------------*/
	int i,j,Count;
	ULONG l;
	UBYTE main_buff[512*8];
	int Block_Len,C_size,C_size_mult,Mult;
	int tmp1,tmp2,tmp3;

	BYTE res, b1;
	char *ptr, *ptr2;
	long p1, p2, p3;
	DWORD dw, ofs, sect = 0;
	WORD w1;
	UINT s1, s2, cnt;
	DIR dir;				/* Directory object */

	FATFS *fs;
	RTCX rtc;
	FRESULT rc;
	long sx, sy, sxx;
	long size, offset;
  	unsigned char **data;			//image data buffer

/*---------------------- initial setttings  --------------------*/
  	PACRL1 = 0x5540;
  	PACRL2 = 0x2140;
  	PBCR1  = 0x000A;
	PBCR2  = 0xA005;
	PCCR   = 0xFFFF;
	PDCRL1 = 0xFFFF;
	PDCRL2 = 0x0000;

	BCR1 = 0x400F;
	BCR2 = 0xFFFF;
	
	WCR1 & 0xF0FF | 0x0F00;     // WAIT = 15,  Memory cycle = 2+15  //WCR1 = 0xFFFF;
	PEDR = PEDR | 0x8000;		// LED OFF

	rtc.year=2009;				/* 1..4095 */
	rtc.month=2;				/* 1..12 */
	rtc.mday=11;				/* 1.. 31 */
	rtc.wday=2; 				/* 1..7 */
	rtc.hour=5; 				/* 0..23 */
	rtc.min=31;					/* 0..59 */
	rtc.sec=46;					/* 0..59 */
	rtc_settime(&rtc);

/*-------------------- start ---------------------*/
	

	CPU_UartInitialize();		/* initialize console(UART) */

	xputs("\t@@@@@@@@@@@@@@@@@@@@@@@@@\n");
	xputs("\t@ CMOS CAMERA INTERFACE @\n");
	xputs("\t@@@@@@@@@@@@@@@@@@@@@@@@@\n");

	MMC_DrverInit();			/* initialize SD-Card socket interface */

	PFC.PEIORL.BIT.B15 = 1;		// PE15:output
	PFC.PEIORL.BIT.B12 = 0;		// PE12:input

	PE.DRL.BIT.B15 = 0;			// LED ON
	for(j=0;j<30000000;j++){}	// wait for a second
	
	MISC = 0x0010;				// RSTB='H'

	PE.DRL.BIT.B15 = 1;			// LED OFF

/*---------------------- I2C -------------------------*/

	SADDT=0x8012;				// reset
	SCTRL=0x0001;
	do{
		tmpus=SCTRL;
		}
	while((tmpus&0x0001)==1);

	SADDT=0x8012;				// reset
	SCTRL=0x0001;
	do{
		tmpus=SCTRL;
		}
	while((tmpus&0x0001)==1);

	SADDT=0x8012;				// reset
	SCTRL=0x0001;
	do{
		tmpus=SCTRL;
		}
	while((tmpus&0x0001)==1);

	for(j=0;j<10000000;j++){}


	SADDT=0x2212;				// BT656
//	SADDT=0x0212;				// RGB for test
//	SADDT=0x0612;				// RGB565 for test
	SCTRL=0x0001;
	do{
		tmpus=SCTRL; }
	while((tmpus&0x0001)==1);

/*-------------------- for test ------------------*/
//	SADDT=0x0312;				// Bayer RAW(1)
//	SCTRL=0x0001;
//	do{
//		tmpus=SCTRL; }
//	while((tmpus&0x0001)==1);
//
//	SADDT=0x0267;				// Bayer RAW(2)
//	SCTRL=0x0001;
//	do{
//		tmpus=SCTRL; }
//	while((tmpus&0x0001)==1);

//	SADDT=0x3066;				// color bar
//	SCTRL=0x0001;
//	do{
//		tmpus=SCTRL; }
//	while((tmpus&0x0001)==1);
/*-------------------- end test -----------------*/

/*------------------ interpreter ----------------*/
begin:
  cq_printf("\nSD-Card Check?...<y>");
  if(xgetc()=='y') goto fat_test;
  else{ 
	  cq_printf("\nFatFs monitor?...<y>");
	  if(xgetc()=='y') goto fat_monitor;
  }
capture:
  CPCTRL=0x0000;			// EE mode
  cq_printf("\nCapture Image?...<y>");
  if(xgetc()!='y') goto begin;
  
  CPCTRL=0x0001;			// Capture start
	do{
		tmpus=CPCTRL;
		}
	while((tmpus&0x0001)==1);

  cq_printf("\nPlayback Image?...<y>");
  if(xgetc()!='y') goto capture;

  CPCTRL=0x8000;			// Playback image

  cq_printf("\nStore to SD-Card?...<y>");
  if(xgetc()!='y') goto capture;

  goto make_bmp;

/*--------------------- I2C TEST ----------------------*/
test_iic:
	while(1) {
		if(PE.DRL.BIT.B12 == 0) {	//B5	((PEDR&0x0020)==0){
  			MISC = 0x0000;			//RSTB='L'
			PE.DRL.BIT.B15 = 0;		//PEDR = 0x5555;	// LED ON
			for(j=0;j<1000;j++){}	// wait
  			MISC = 0x0010;			//RSTB='H'
			for(j=0;j<1000;j++){}	// wait
		
			SADDT=0x8012;			// reset
			SCTRL=0x0001;
			do{
				tmpus=SCTRL;
			}
			while((tmpus&0x0001)==1);

			SADDT=0x0212;			// RGB
			SCTRL=0x0001;
			do{
				tmpus=SCTRL; }
			while((tmpus&0x0001)==1);
			
/*----------------------BT656----------------------*/
			SADDT=0x2212;			//BT656
			SCTRL=0x0001;
			do{
				tmpus=SCTRL; }
			while((tmpus&0x0001)==1);

/*----------------------QVGA TEST------------------*/
/*			SADDT=0x4212;			//QVGA
			SCTRL=0x0001;
			do{
				tmpus=SCTRL; }
			while((tmpus&0x0001)==1);	*/
/*-------------------------------------------------*/

			for(j=0;j<10000000;j++){}	// LED interval
			PE.DRL.BIT.B15 = 1;			// LED OFF
		}
  	}

fat_test:
/**********************************************************************/
	i=MMC_CardInit();					/* MMCJ[h */
	if (i) {
		cq_printf("Card Initialize Error! %d\n",i);
	}
	
	cq_printf("\nCID = ");				/* CIDWX^l̎擾\ */
	i=MMC_GetCID(main_buff);
	if (i) {
		cq_printf(" Get Error!  error code=%Xh\n",i);
	} else {
		for(i=0;i<16;i++){				/* CID 16i_v\ */
			cq_printf("%02X ",main_buff[i]);
		}
		cq_printf("\n");
		cq_printf("Manufacturer ID : %02Xh\n",main_buff[0]);		/* CIDڕ\ */
		cq_printf("OEM/Application ID : %02X%02Xh\n",main_buff[1],main_buff[2]);	/* oCg琬f[^MSB */
		cq_printf("Product Name : '");
		for(i=0;i<6;i++){
			cq_printf("%c",main_buff[3+i]);
		}
		cq_printf("'\nProduct Revision : %02Xh\n",main_buff[9]);
		cq_printf("Product Serial Number : %02X%02X%02X%02Xh\n",main_buff[10],main_buff[11],main_buff[12],main_buff[13]);
		cq_printf("Manufacturing Date : %02Xh\n",main_buff[14]);
		cq_printf("CRC : %02Xh\n",main_buff[15]);
	}
	
	cq_printf("\nCSD = ");					/* CSDWX^l̎擾\ */
	i=MMC_GetCSD(main_buff);
	if (i) {
		cq_printf(" Get Error!  error code=%Xh\n",i);
	}
	for(i=0;i<16;i++){
		cq_printf("%02X ",main_buff[i]);
	}
											/* CSDWX^lJ[heʌvZ */
    Block_Len = 1<<(main_buff[5] & 0xf);	/* ItZbg+5̉4rbgoBlock_Len */
	tmp1 = (main_buff[ 6] & 3) << 10;		/* ItZbg+6̉2rbgoărbg11`10 */
	tmp2 =  main_buff[ 7] << 2;				/* ItZbg+78rbgoărbg9`2 */
	tmp3 = (main_buff[ 8] >> 6) & 3;		/* ItZbg+8̏2rbgoărbg1`0 */
	C_size = tmp1 | tmp2 | tmp3;			/* C_SIZElvZ */
	tmp1 = (main_buff[ 9] & 3) << 1;		/* ItZbg+9̉2rbgoărbg2`1 */
	tmp2 = (main_buff[10] >> 7) & 1;		/* ItZbg+10̏1rbgoărbg0 */
	C_size_mult = tmp1 | tmp2;				/* C_SIZE_MULTlvZ*/
	Mult = 1 << (C_size_mult+2);			/* MultlvZ */
	l    = (C_size + 1) * Mult * (Block_Len / 512);

											/* ep[^\ */
	cq_printf("\nMMC Spec Verison = %d\n",(main_buff[0]>>2)&0xF);
	cq_printf("C_SIZE_MULT = %d\n",C_size_mult);
	cq_printf("C_SIZE      = %d\n",C_size);
	cq_printf("MULT        = %d\n",Mult);
	cq_printf("BLOCK_LEN   = %d\n",Block_Len);
	cq_printf("MAX LBA     = %ld\n",l);

	goto jump;

											/* ZN^CgeXg */
	Count=8;								/* 8ZN^Pʂŏ */
	cq_printf("\nSector Write ... ");
	for(l=0;l<256;l=l+Count){
		for(j=0;j<Count;j++){
			for(i=0;i<512;i++){
				main_buff[j*512+i]=0xAB;	//(UBYTE)(l+j+i);
			}
		}
		i=MMC_Write(l,main_buff,Count);		/* ZN^Cg */
		if (i) {
			cq_printf("\nLBA=%ld  Write Error! error code=%d\n",l,i);
			break;
		}
	}
	cq_printf("Sector Write Done!\n");

jump:

	Count=8;								/* 8ZN^Pʂœǂݏo */
	for(l=0;l<32;l=l+Count){
		cq_printf("\nLBA=%ld~%ld  Read Sector Count = %d\n",l,l+Count-1,Count);
		i=MMC_Read(l,main_buff,Count);		/* ZN^[h */
		if (i) {
			cq_printf("LBA=%ld  Read Error! error code=%d\n",l,i);
		} else {
			for(i=0;i<Count;i++){
				buffer_dump(&main_buff[i*512], 32);	/* eZN^̐擪32oCg_v */
			}
		}
	}

	cq_printf("Sector Read Done!\n");
	
	goto begin;

fat_monitor:
/**************************************************************************************/

	xputs("\nFatFs module test monitor\n");

	for (;;) {
		xputc('>');
		ptr = linebuf;
		get_line(ptr, sizeof(linebuf));

		switch (*ptr++) {

		case 'd' :
			switch (*ptr++) {
			case 'd' :	/* dd [<sector>] - Dump secrtor */
				if (!xatoi(&ptr, &p1))
					p1 = sect;
				res = disk_read(0, Buff, p1, 1);
				if (res) { cq_printf("rc=%u\n", (WORD)res); break; }
				sect = p1 + 1;
				cq_printf("Sector:%u\n", p1);
				for (ptr = (char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
					put_dump((BYTE*)ptr, ofs, 16);
				break;

			case 'i' :	/* di - Initialize disk */
				cq_printf("rc=%u\n", (WORD)disk_initialize(0));
				break;

			case 's' :	/* ds - Show disk status */

				if (disk_ioctl(0, GET_SECTOR_COUNT, &p2) == RES_OK)
					{ cq_printf("Drive size: %u sectors\n", p2); }
				if (disk_ioctl(0, GET_SECTOR_SIZE, &w1) == RES_OK)
					{ cq_printf("Sector size: %u\n", w1); }
				if (disk_ioctl(0, GET_BLOCK_SIZE, &p2) == RES_OK)
					{ cq_printf("Erase block size: %u sectors\n", p2); }
				if (disk_ioctl(0, MMC_GET_TYPE, &b1) == RES_OK)
					{ cq_printf("MMC/SDC type: %u\n", b1); }
				if (disk_ioctl(0, MMC_GET_CSD, Buff) == RES_OK)
					{ xputs("CSD:"); put_dump(Buff, 0, 16); }
				if (disk_ioctl(0, MMC_GET_CID, Buff) == RES_OK)
					{ xputs("CID:"); put_dump(Buff, 0, 16); }
				if (disk_ioctl(0, MMC_GET_OCR, Buff) == RES_OK)
					{ xputs("OCR:"); put_dump(Buff, 0, 4); }
				if (disk_ioctl(0, MMC_GET_SDSTAT, Buff) == RES_OK) {
					xputs("SD Status:");
					for (s1 = 0; s1 < 64; s1 += 16) put_dump(Buff+s1, s1, 16);
				}
				break;
			}
			break;

		case 'b' :
			switch (*ptr++) {
			case 'd' :	/* bd <addr> - Dump R/W buffer */
				if (!xatoi(&ptr, &p1)) break;
				for (ptr=(char*)(&Buff[p1]), ofs = p1, cnt = 32; cnt; cnt--, ptr+=16, ofs+=16)
					put_dump((BYTE*)ptr, ofs, 16);
				break;

			case 'e' :	/* be <addr> [<data>] ... - Edit R/W buffer */
				if (!xatoi(&ptr, &p1)) break;
				if (xatoi(&ptr, &p2)) {
					do {
						Buff[p1++] = (BYTE)p2;
					} while (xatoi(&ptr, &p2));
					break;
				}
				for (;;) {
					cq_printf("%04X %02X-", (WORD)(p1), (WORD)Buff[p1]);
					get_line(linebuf, sizeof(linebuf));
					ptr = linebuf;
					if (*ptr == '.') break;
					if (*ptr < ' ') { p1++; continue; }
					if (xatoi(&ptr, &p2))
						Buff[p1++] = (BYTE)p2;
					else
						xputs("???\n");
				}
				break;

			case 'r' :	/* br <sector> <n> - Read disk into R/W buffer */
				if (!xatoi(&ptr, &p1)) break;
				if (!xatoi(&ptr, &p2)) p2 = 1;
				cq_printf("rc=%u\n", (WORD)disk_read(0, Buff, p1, p2));
				break;

			case 'w' :	/* bw <sector> <n> - Write R/W buffer into disk */
				if (!xatoi(&ptr, &p1)) break;
				if (!xatoi(&ptr, &p2)) p2 = 1;
				cq_printf("rc=%u\n", (WORD)disk_write(0, Buff, p1, p2));
				break;

			case 'f' :	/* bf <n> - Fill R/W buffer */
				if (!xatoi(&ptr, &p1)) break;
				memset(Buff, (BYTE)p1, sizeof(Buff));
				break;

			}
			break;

		case 'f' :
			switch (*ptr++) {

			case 'i' :	/* fi - Initialize logical drive */
				put_rc(f_mount(0, &fatfs));
				break;

			case 's' :	/* fs - Show file system status */
				res = f_getfree("", (DWORD*)&p2, &fs);
				if (res) { put_rc(res); break; }
				cq_printf("FAT type = %u\nBytes/Cluster = %u\nNumber of FATs = %u\n"
						"Root DIR entries = %u\nSectors/FAT = %u\nNumber of clusters = %u\n"
						"FAT start (lba) = %u\nDIR start (lba,clustor) = %u\nData start (lba) = %u\n",
						(WORD)fs->fs_type, (DWORD)fs->csize * 512, (WORD)fs->n_fats,
						fs->n_rootdir, (DWORD)fs->sects_fat, (DWORD)(fs->max_clust - 2),
						fs->fatbase, fs->dirbase, fs->database
				);
				acc_size = acc_files = acc_dirs = 0;
				res = scan_files(ptr);
				if (res) { put_rc(res); break; }
				cq_printf("%u files, %u bytes.\n%u folders.\n"
						"%u bytes total disk space.\n%u bytes available.\n",
						acc_files, acc_size, acc_dirs,
						(DWORD)(fs->max_clust - 2) * fs->csize * 512, (DWORD)p2 * fs->csize * 512
				);
				break;

			case 'l' :	/* fl [<path>] - Directory listing */
				res = f_opendir(&dir, ptr);
				if (res) { put_rc(res); break; }
				p1 = s1 = s2 = 0;
				for(;;) {
					res = f_readdir(&dir, &finfo);
					if ((res != FR_OK) || !finfo.fname[0]) break;
					if (finfo.fattrib & AM_DIR) {
						s2++;
					} else {
						s1++; p1 += finfo.fsize;
					}
					cq_printf("%c%c%c%c%c %u/%02u/%02u %02u:%02u %9u  %s\n", 
							(finfo.fattrib & AM_DIR) ? 'D' : '-',
							(finfo.fattrib & AM_RDO) ? 'R' : '-',
							(finfo.fattrib & AM_HID) ? 'H' : '-',
							(finfo.fattrib & AM_SYS) ? 'S' : '-',
							(finfo.fattrib & AM_ARC) ? 'A' : '-',
							(finfo.fdate >> 9) + 1980, (finfo.fdate >> 5) & 15, finfo.fdate & 31,
							(finfo.ftime >> 11), (finfo.ftime >> 5) & 63,
							finfo.fsize, &(finfo.fname[0]));
				}
				cq_printf("%4u File(s),%10u bytes\n%4u Dir(s)", s1, p1, s2);
				if (f_getfree(ptr, (DWORD*)&p1, &fs) == FR_OK)
					cq_printf(", %10uK bytes free\n", p1 * fs->csize / 2);
				break;

			case 'o' :	/* fo <mode> <file> - Open a file */
				if (!xatoi(&ptr, &p1)) break;
				res = f_open(&file1, ptr, (BYTE)p1);
				put_rc(res);
				break;

			case 'c' :	/* fc - Close a file */
				res = f_close(&file1);
				put_rc(res);
				break;

			case 'e' :	/* fe - Seek file pointer */
				if (!xatoi(&ptr, &p1)) break;
				res = f_lseek(&file1, p1);
				put_rc(res);
				if (res == FR_OK)
					cq_printf("fptr = %u(0x%lX)\n", file1.fptr, file1.fptr);
				break;

			case 'r' :	/* fr <len> - read file */
				if (!xatoi(&ptr, &p1)) break;
				p2 = 0;
				while (p1) {
					if (p1 >= sizeof(Buff))	{ cnt = sizeof(Buff); p1 -= sizeof(Buff); }
					else 			{ cnt = (WORD)p1; p1 = 0; }
					res = f_read(&file1, Buff, cnt, &s2);
					if (res != FR_OK) { put_rc(res); break; }
					p2 += s2;
					if (cnt != s2) break;
				}
				cq_printf("%u bytes read with %u bytes/sec.\n", p2, p2 * 100 / s2);
				break;

			case 'd' :	/* fd <len> - read and dump file from current fp */
				if (!xatoi(&ptr, &p1)) break;
				ofs = file1.fptr;
				while (p1) {
					if (p1 >= 16)	{ cnt = 16; p1 -= 16; }
					else 			{ cnt = (WORD)p1; p1 = 0; }
					res = f_read(&file1, Buff, cnt, &cnt);
					if (res != FR_OK) { put_rc(res); break; }
					if (!cnt) break;
					put_dump(Buff, ofs, cnt);
					ofs += 16;
				}
				break;

			case 'w' :	/* fw <len> <val> - write file */
				if (!xatoi(&ptr, &p1) || !xatoi(&ptr, &p2)) break;
				memset(Buff, (BYTE)p2, sizeof(Buff));
				p2 = 0;
				while (p1) {
					if (p1 >= sizeof(Buff))	{ cnt = sizeof(Buff); p1 -= sizeof(Buff); }
					else 			{ cnt = (WORD)p1; p1 = 0; }
					res = f_write(&file1, Buff, cnt, &s2);
					if (res != FR_OK) { put_rc(res); break; }
					p2 += s2;
					if (cnt != s2) break;
				}
				cq_printf("%u bytes written with %u bytes/sec.\n", p2, p2 * 100 / s2);
				break;

			case 'v' :	/* fv - Truncate file */
				put_rc(f_truncate(&file1));
				break;

			case 'n' :	/* fn <old_name> <new_name> - Change file/dir name */
				while (*ptr == ' ') ptr++;
				ptr2 = strchr(ptr, ' ');
				if (!ptr2) break;
				*ptr2++ = 0;
				while (*ptr2 == ' ') ptr2++;
				put_rc(f_rename(ptr, ptr2));
				break;

			case 'u' :	/* fu <name> - Unlink a file or dir */
				put_rc(f_unlink(ptr));
				break;

			case 'k' :	/* fk <name> - Create a directory */
				put_rc(f_mkdir(ptr));
				break;

			case 'a' :	/* fa <atrr> <mask> <name> - Change file/dir attribute */
				if (!xatoi(&ptr, &p1) || !xatoi(&ptr, &p2)) break;
				put_rc(f_chmod(ptr, p1, p2));
				break;

			case 't' :	/* ft <year> <month> <day> <hour> <min> <sec> <name> */
				if (!xatoi(&ptr, &p1) || !xatoi(&ptr, &p2) || !xatoi(&ptr, &p3)) break;
				finfo.fdate = ((p1 - 1980) << 9) | ((p2 & 15) << 5) | (p3 & 31);
				if (!xatoi(&ptr, &p1) || !xatoi(&ptr, &p2) || !xatoi(&ptr, &p3)) break;
				finfo.ftime = ((p1 & 31) << 11) | ((p1 & 63) << 5) | ((p1 >> 1) & 31);
				put_rc(f_utime(ptr, &finfo));
				break;

			case 'x' : /* fx <src_name> <dst_name> - Copy file */
				while (*ptr == ' ') ptr++;
				ptr2 = strchr(ptr, ' ');
				if (!ptr2) break;
				*ptr2++ = 0;
				if (!*ptr2) break;
				cq_printf("Opening \"%s\"", ptr);
				res = f_open(&file1, ptr, FA_OPEN_EXISTING | FA_READ);
				xputc('\n');
				if (res) {
					put_rc(res);
					break;
				}
				cq_printf("Creating \"%s\"\n", ptr2);
				res = f_open(&file2, ptr2, FA_CREATE_ALWAYS | FA_WRITE);
				xputc('\n');
				if (res) {
					put_rc(res);
					f_close(&file1);
					break;
				}
				cq_printf("Copying...");
				p1 = 0;
				for (;;) {
					res = f_read(&file1, Buff, sizeof(Buff), &s1);
					if (res || s1 == 0) break;   /* error or eof */
					res = f_write(&file2, Buff, s1, &s2);
					p1 += s2;
					if (res || s2 < s1) break;   /* error or disk full */
				}
				cq_printf("\n%u bytes copied.\n", p1);
				f_close(&file1);
				f_close(&file2);
				break;

			}
			break;

		case 't' :	/* t [<year> <mon> <mday> <hour> <min> <sec>] */
			if (xatoi(&ptr, &p1)) {
				rtc.year = (WORD)p1;
				xatoi(&ptr, &p1); rtc.month = (BYTE)p1;
				xatoi(&ptr, &p1); rtc.mday = (BYTE)p1;
				xatoi(&ptr, &p1); rtc.hour = (BYTE)p1;
				xatoi(&ptr, &p1); rtc.min = (BYTE)p1;
				if (!xatoi(&ptr, &p1)) break;
				rtc.sec = (BYTE)p1;
				rtc_settime(&rtc);
			}
			rtc_gettime(&rtc);
			cq_printf("%u/%u/%u %02u:%02u:%02u\n\r", rtc.year, rtc.month, rtc.mday, rtc.hour, rtc.min, rtc.sec);
			break;
		
		case 'q' : 
			goto begin;

		}

	}


/***********************************************************************************************/

make_bmp:

  res=disk_initialize(0);
  cq_printf("rc=%d\n\r", res);
  //rc=f_mount(0, &fatfs[0]);
  //put_rc(rc);
  put_rc(f_mount(0, &fatfs));

  cq_printf("make BMP File?...<y>");
  if(xgetc()!='y') goto terminate;

  CPCTRL=0x0000;			// EE mode


  for(j=0; j<16; j++) {
	  xBuffer[j] = 0;							// clear buffer
  }

	if(FileOpen() == 0)							// t@CI[v
	{				
												// t@CI[vłꍇ
		cq_printf("Open File Correctly\n");
		//Index = 0;
												// t@Cwb_
		sx = 640;
		sy = 480;
		sxx = sx*3;
		if (sxx % 4 != 0){
			size = ((sxx/4 + 1)*4)*sy;
		}
		else{
			size = sxx * sy;
		}
		offset = 14 + 40;				//offset to image data=header size
		fileheader(size, offset);		//file header
					
		bitmapheader(sx, sy, size);		//Info header
					
		imagedata(sxx,sy,data,offset);	//image data
					

	}		
	else {								// t@CI[vG[̏ꍇ 
			cq_printf("File Open Failed.\n");
	}
	f_close(&file1);					// t@CN[Y
	//Index = 0;
	cq_printf("File Closed\n");

terminate:								// the end
	while(1){
		PE.DRL.BIT.B15 = 0;				// LED ON
		for(j=0;j<10000000;j++){}		// ҂
		PE.DRL.BIT.B15 = 1;				// LED OFF
		for(j=0;j<10000000;j++){}		// ҂
	}


}		// end of main


/******************************************Sub Routine******************************************/

static
FRESULT scan_files (char* path)
{
	DIR dirs;
	FRESULT res;
	BYTE i;


	if ((res = f_opendir(&dirs, path)) == FR_OK) {
		i = strlen(path);
		while (((res = f_readdir(&dirs, &finfo)) == FR_OK) && finfo.fname[0]) {
			if (finfo.fattrib & AM_DIR) {
				acc_dirs++;
				*(path+i) = '/'; strcpy(path+i+1, &finfo.fname[0]);
				res = scan_files(path);
				*(path+i) = '\0';
				if (res != FR_OK) break;
			} else {
				acc_files++;
				acc_size += finfo.fsize;
			}
		}
	}

	return res;
}

static
void put_rc (FRESULT rc)
{
	const char *p;
	static const char str[] =
		"OK\0" "NOT_READY\0" "NO_FILE\0" "NO_PATH\0" "INVALID_NAME\0" "INVALID_DRIVE\0"
		"DENIED\0" "EXIST\0" "RW_ERROR\0" "WRITE_PROTECTED\0" "NOT_ENABLED\0"
		"NO_FILESYSTEM\0" "INVALID_OBJECT\0";
	FRESULT i;

	for (p = str, i = 0; i != rc && *p; i++) {
		while(*p++);
	}
	cq_printf("rc=%u FR_%s\n", (WORD)rc, p);
}

/******************************************BMP Sub Routine***************************************/

unsigned char FileOpen(void)
{
	unsigned int i;
	BYTE res;

    res = f_open(&file1, FileName, FA_OPEN_ALWAYS | FA_CREATE_NEW | FA_WRITE);		//FileName[i]
	if(res)
		return(0xFF);				// open error	
	else
		return(0);					// open correctry
}


int fileheader(long size, long offset){
	DWORD writeSize;							// FATpϐ	
	long filesize, tmp;
	short reserved = 0;
	char s[2];
	BYTE res;
	UINT s2;

	cq_printf("fileheader\n");

    res = f_lseek(&file1, 0);					//rewind(fp);
	put_rc(res);
	s[0] = 'B';									// ʕ@al
	s[1] = 'M';
	res = f_write(&file1, s, sizeof(short), &s2);
//	put_rc(res);
	filesize = INV_INT32(size + offset);
	res = f_write(&file1, &filesize, sizeof(long), &s2);
//	put_rc(res);
	res = f_write(&file1, &reserved, sizeof(short), &s2);		//reserved area;bfReserved1
//	put_rc(res);
	res = f_write(&file1, &reserved, sizeof(short), &s2);		//reserved area;bfReserved2
//	put_rc(res);
	tmp = INV_INT32(offset);
	res = f_write(&file1, &tmp, sizeof(long), &s2);				//offset to data area
//	put_rc(res);
	return (0);
}

/*-----------------------------*/
/* wb_ BITMAPINFOHEADER */
/*-----------------------------*/
int bitmapheader(long width, long height, long size)
{
  long var_long;
  short var_short;
  UINT s2;
  BYTE res;

  cq_printf("bitmapheader\n");
	
  f_lseek(&file1, 14);

  // wb_̃TCY biSize (Windows BMP  40) 
  var_long = INV_INT32((long)40);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // 摜̕ biWidth 
  var_long = INV_INT32(width);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // 摜̍ biHeight 
  // (Ȃ΍E, }CiXȂ΍ォE) 
  var_long = INV_INT32(-height);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // v[ biPlanes (K 1) 
  var_short = INV_INT16((short)1);
  res=f_write(&file1, &var_short, sizeof(short), &s2);
  put_rc(res);
  // 1sNZ̃f[^ biBitCount (1, 4, 8, 24, 32) 
  var_short = INV_INT16((short)24);	//BITCOUNT;
  res=f_write(&file1, &var_short, sizeof(short), &s2);
  put_rc(res);

  // k biCompression (kȂ 0) 
  var_long = INV_INT32((long)0);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // 摜̃TCY biSizeImage 
  var_long = INV_INT32(size);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // 𑜓x pixel/m biXPelPerMeter 
  // (96dpi, 1inch = 0.0254m ̂Ƃ 96/0.0254 = 3780) 
  var_long = INV_INT32((long)3780);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // c𑜓x pixel/m biYPelPerMeter 
  // (96dpi, 1inch = 0.0254m ̂Ƃ 96/0.0254 = 3780) 
  var_long = INV_INT32((long)3780);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // pbg biClrUsed 
  var_long = INV_INT32((long)0);	//1 << BITCOUNT;
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);
  // pbg̏dvȐF  biClrImportant 
  var_long = INV_INT32((long)0);
  res=f_write(&file1, &var_long, sizeof(long), &s2);
  put_rc(res);

  return (0);
}	

//摜f[^]
long imagedata(int x, int y, unsigned char **data, long offset)
{
  unsigned long i, j, Index=0;
  UINT s2;
  BYTE res;
  unsigned short *pixAddr;
  unsigned short pix;
  unsigned char  sigR, sigG, sigB;
  
  cq_printf("imagedata\n");
	
  res=f_lseek(&file1, offset);
  put_rc(res);
  cq_printf("calc start\n");

  MISC = 0x0020;			// SRAM Access Enable
  pixAddr = &MEM0;			// sram address
  sigR = 0;
  sigG = 0;
  sigB = 0;

  for(j=0; j<y; j++){						//s肩
		for(i=0; i<x/3; i++){				//s
			pix = *(pixAddr + i++ + j*640);		//fTv
			sigR = (unsigned char)pix;		//GR -> RGBϊ
			sigG = pix >>8;
			xBuffer[Index++]= sigB;	//sigG;
			xBuffer[Index++]= sigG;	//sigB;
			xBuffer[Index++]= sigR;			//obt@Ɋi[
			pix = *(pixAddr + i + j*640);		//fTv
			sigG = pix >>8;					//GB -> RGBϊ
			sigB = (unsigned char)pix;
			xBuffer[Index++]= sigB;	//sigG;
			xBuffer[Index++]= sigG;	//sigB;
			xBuffer[Index++]= sigR;			//obt@Ɋi[
		}
		if ((x % 4) != 0){					//SoCgE
			for(i=0; i<((x/4+1)*4)-x; i++){
				xBuffer[Index++]=0x00;
			}
      	}
      	res=f_write(&file1, (const void*)xBuffer, Index, &s2);	//sƂɃt@Co
      	Index = 0;
  }
  
  

  MISC = 0x0000;		//SRAM Access Disable


}






#ifdef __cplusplus
void abort(void)
{

}
#endif


